# -*- autoconf -*-
# $Id: jni.m4,v 1.1 2004/03/17 15:32:25 admin Exp $
# :: Configure paths for Java Native Interface ::

dnl AM_PATH_JNI([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl Test for javah, JNI headers and libraries,
dnl then define JAVAH, JNI_CFLAGS, JNI_LIBS
AC_DEFUN(AM_PATH_JNI,
[dnl
dnl check for programs, etc
dnl
AC_PATH_PROG(JAVAH, javah, [])
AC_PATH_PROG(JAVACONFIG, javaconfig, [])
if test "x$JAVACONFIG" = "x"; then
    :
else
    AC_MSG_CHECKING([for JNI])
    JNI_CFLAGS=-I`$JAVACONFIG Headers`
    JNI_LIBS=`$JAVACONFIG Library`
    AC_MSG_RESULT([CFLAGS=$JNI_CFLAGS LIBS=$JNI_LIBS])
fi

if (test "x$JAVAH" = "x" || test "x$JAVACONFIG" = "x"); then
    ifelse([$2], , :, [$2])
else
    ifelse([$1], , :, [$1])
fi

AC_SUBST([JAVAH])
AC_SUBST([JNI_CFLAGS])
AC_SUBST([JNI_LIBS])
])
