/* -*- c++ -*-
   $Id: shioribox_controller_jni.h,v 1.1 2004/03/17 15:32:25 admin Exp $
*/
#ifndef _SHIORIBOX_CONTROLLER_JNI_H_INCLUDED_
#define _SHIORIBOX_CONTROLLER_JNI_H_INCLUDED_
#include <jni.h>
#include <boost/utility.hpp>
#include <boost/shared_ptr.hpp>

namespace shioribox {
    namespace ctrl {
	class controller_jni;
    };
};

/*
  Υ饹ϥåɥդǤϤޤ
  JavaƤֻˤϡΥ᥽åɤɬsynchronizedˤƲ
*/

class shioribox::ctrl::controller_jni : boost::noncopyable {
private:
    class impl;
    // scoped_ptrȤimplԴʤΤǻȤʤ
    boost::shared_ptr<impl> pimpl;
    // 󥹥ȥ饯private
    controller_jni();
    
public:
    ~controller_jni() {}
    
    // ʲλĤΥ᥽åɤϤɤ java.lang.RuntimeException ꤲǽ롣
    // openContext ID֤
    static int open(
	JNIEnv *env,
	const jstring shioribox_path, // shioriboxХʥؤΥѥ
	const jstring shiori_name, // shioriboxΥץ̾˻Ȥ̾
	const jstring shiori_module, // ΤؤΥѥ
	const jobject additional_env, // ɲäĶѿnullġHashtable<String, String>
	const jstring ghost_path); // ٤load()Ϥѥ
    static jbyteArray request(
	JNIEnv *env,
	int context_id,
	const jbyteArray req);
    static void close(
	JNIEnv *env,
	int context_id);
};

#endif /* _SHIORIBOX_CONTROLLER_JNI_H_INCLUDED_ */
